/*
 * Copyright (c) 2011 Lucas Baudin <xapantu@gmail.com>
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; see the file COPYING.  If not,
 * write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 */

public class Euclide.SourceView : Gtk.SourceView
{
    public static bool on_insert_event(Gtk.Widget view, Gdk.EventKey event)
    {
        Gtk.TextView text_view = (Gtk.TextView)view;
        if(event.keyval == 0xff0d)
        {
            Gtk.TextBuffer buffer = text_view.get_buffer ();
            Gtk.TextIter iter;
            buffer.get_iter_at_offset(out iter, buffer.cursor_position);
            Gtk.TextIter iter_first = iter;
            iter_first.backward_char();
            if(iter_first.get_text(iter) == "{")
            {
                iter_first.set_line_offset(0);
                string text = iter_first.get_text(iter);
                string indentation = "";
                for(int i = 0; i < text.length; i++)
                {
                    if(text[i] != ' ' && text[i] != '\t')
                    {
                        break;
                    }
                    indentation += text[i].to_string();
                }
                    buffer.insert_at_cursor("\n" + indentation + "    ", -1);
                    /*buffer.insert_at_cursor("\n" + indentation + "\t", -1);*/
                return true;
            }
            
            /* Let's see if it was a comment */
            iter_first.set_line_offset(0);
            unichar precedent = 'a';
            bool comment = false;
            iter.backward_find_char( (ch) => {
                if(ch == '/' && precedent == '*')
                {
                    comment = true;
                    return true;
                }
                else if(ch == '*' && precedent == '/')
                    return true;
                precedent = ch;
                return false;
            }, null);
            if(comment)
            {
                iter_first = iter;
                iter_first.set_line_offset(0);
                string text = iter_first.get_text(iter);
                string indentation = "";
                for(int i = 0; i < text.length; i++)
                {
                    if(text[i] != ' ' && text[i] != '\t')
                    {
                        break;
                    }
                    indentation += text[i].to_string();
                }
                buffer.insert_at_cursor("\n" + indentation + " * ", -1);
                return true;
            }
            
        }
        else if(event.keyval == 0x7d) /* } */
        {
            Gtk.TextBuffer buffer = text_view.get_buffer();
            Gtk.TextIter iter = Gtk.TextIter();
            buffer.get_iter_at_offset(out iter, buffer.cursor_position);

            Gtk.TextIter iter_first = iter;
            iter_first.set_line_offset(0);
            string text = iter_first.get_text(iter);
            bool other_text = false;
            for(int i = 0; i < text.length; i++)
            {
                if(text[i] != ' ' && text[i] != '\t')
                {
                    other_text = true;
                    break;
                }
            }
            if(!other_text)
            {
                Gtk.TextIter previous_iter = iter;
                Gtk.TextIter previous_iter_first = iter_first;
                int count = 2;
                iter.backward_find_char( (ch) => {
                    if(ch == '{')
                    {
                        count -= 1;
                    }
                    else if(ch == '}')
                        count += 1;
                    return count == 1;
                }, null);

                iter_first = iter;
                iter_first.set_line_offset(0);

                text = iter_first.get_text(iter);
                string indentation = "";
                for(int i = 0; i < text.length; i++)
                {
                    if(text[i] != ' ' && text[i] != '\t')
                    {
                        break;
                    }
                    indentation += text[i].to_string();
                }
                buffer.delete (ref previous_iter_first, ref previous_iter);
                buffer.insert_at_cursor(indentation + "}", -1);
                return true;
            }
        }
        return false;
    }
}
