/*
 * Copyright (c) 2011 Lucas Baudin <xapantu@gmail.com>
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; see the file COPYING.  If not,
 * write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 */

public class ProgramCloseTab : Gtk.HBox
{
    Gtk.Widget content;
    bool _modified;
    string label;
    Gtk.Label label_widget;
    public bool modified
    {
        get { return _modified; }
        set { _modified = value; label_widget.set_text((modified ? "*" : "") + label); }
    }
    public ProgramCloseTab(string label_, Gtk.Widget content_)
    {
        content = content_;
        label = label_;
        label_widget = new Gtk.Label(label);
        pack_start(label_widget);
        var button = new Gtk.Button();
        button.clicked.connect( () => {
            content.destroy();
        });
        button.add(new Gtk.Image.from_stock(Gtk.Stock.CLOSE, Gtk.IconSize.MENU));
        button.set_relief(Gtk.ReliefStyle.NONE);
        button.set_focus_on_click(false);
        var style = new Gtk.RcStyle();
        style.xthickness = 0;
        style.ythickness = 0;
        button.modify_style(style);
        pack_start(button);
        set_orientation(Gtk.Orientation.HORIZONTAL);
        show_all();
    }
    
    public void set_label(string label)
    {
        this.label = label;
        modified = modified;
    }
}