public class Granite.Widgets.FlowBox : Gtk.Grid
{
    List<Gtk.Widget> children;
    public FlowBox()
    {
        children = new List<Gtk.Widget>();
    }
    
    public override void add(Gtk.Widget widget)
    {
        children.append(widget);
        recompute();
        show_all();
    }
    
    public override void remove(Gtk.Widget widget)
    {
        children.remove(widget);
        recompute();
    }
    
    void recompute()
    {
        
        /* empty the widget */
        foreach(var widget in get_children())
        {
            var grid = widget as Gtk.Container;
            foreach(var w in grid.get_children())
                grid.remove(w);
        }
        
        int row = 0;
        int column = 0;
        int width = get_allocated_width();
        int row_width = width;
        Gtk.Grid current_grid = new Gtk.Grid();
        attach(current_grid, 0, row, 1, 1);
        foreach(var w in children)
        {
            int minimum_width;
            w.get_preferred_width(null, out minimum_width);
            minimum_width += w.margin_right + w.margin_right;
            if(minimum_width > row_width) /* then... new line! */
            {
                row++;
                column = 0;
                row_width = width;
                current_grid = new Gtk.Grid();
                attach(current_grid, 0, row, 1, 1);
            }
            row_width -= minimum_width;
            current_grid.attach(w, column, 0, 1, 1);
            column ++;
        }
    }
    
    public override void size_allocate(Gtk.Allocation alloc)
    {
        recompute();
        base.size_allocate(alloc);
    }
}