/*
 * Copyright (c) 2011 Lucas Baudin <xapantu@gmail.com>
 *
 * This is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; see the file COPYING.  If not,
 * write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 */

using Gtk;

Peas.ExtensionSet euclide_extension_set;

public class Euclide.PluginManager : GLib.Object
{
    public PluginManager(Gtk.Widget? window)
    {
        load_euclide_plugin();
        Peas.Engine engine = Peas.Engine.get_default();
        engine.enable_loader("python");
        debug("Plugin dir: %s\n", Build.RESSOURCES_DIR + "/plugins");
        engine.add_search_path(Build.RESSOURCES_DIR + "/plugins/", null);
        euclide_settings.bind("plugins-enabled", engine, "loaded-plugins",SettingsBindFlags.DEFAULT);
        euclide_extension_set = create_set(window);
    }
}

public class Euclide.PluginDialog : Gtk.Dialog
{
    public PluginDialog()
    {
        VBox vbox = (VBox)get_content_area();
        set_title("Plugins - Euclide");
        var peasgtk = new PeasGtk.PluginManager(Peas.Engine.get_default());
        vbox.pack_start(peasgtk);
        add_buttons(Stock.CLOSE, ResponseType.OK, null);
        show_all();
        run();
        destroy();
    }
}