using Gtk;

public class Euclide.SettingsDialog : Dialog
{
    public SettingsDialog(Window parent, GLib.Settings settings)
    {
        set_modal(true);
        set_transient_for(parent);
        set_title("Settings - Euclide");
        set_resizable(false);
        add_buttons(Stock.CLOSE, ResponseType.OK, null);
        Box box_ = (Box)get_content_area();
        var box = new Gtk.VBox(false, 2);
        box_.pack_start(box);
        box.border_width = 6;
        
        var switch_tabs = new Switch();
        settings.bind("space-for-tabs", switch_tabs, "active", SettingsBindFlags.DEFAULT);
        var hbox = new HBox(false, 5);
        var label = new Label("Use spaces instead of tabs:");
        label.set_alignment(0.0f, 0.5f);
        hbox.pack_start(label);
        hbox.pack_start(switch_tabs, false, false);
        box.pack_start(hbox);
        
        hbox = new HBox(false, 5);
        var spin_button = new SpinButton.with_range(1, 16, 1);
        settings.bind("tabs-width", spin_button, "value", SettingsBindFlags.DEFAULT);
        label = new Label("Tabs width:");
        label.set_alignment(0.0f, 0.5f);
        hbox.pack_start(label);
        hbox.pack_start(spin_button, false, false);
        
        box.pack_start(hbox);

        show_all();
        run();
        destroy();
    }
}