/*
 * Copyright (c) 2011 Lucas Baudin <xapantu@gmail.com>
 *
 * This is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; see the file COPYING.  If not,
 * write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 */

    public class Euclide.Animation.Container : Gtk.Box {
 
        private int width;
        private double height;
        private uint timer_id;
        private double step;
        private double target;
        public new Gtk.HBox child;

        public Container() {
            this.width = 0;
            this.height = 0;
            set_orientation(Gtk.Orientation.VERTICAL);
            child = new Gtk.HBox(false, 2);
            view = new Gtk.Layout();
            view.put(child,0,0);
            pack_start(view, true, true);
            view.height_request = 0;
            expand = false;
        }
        Gtk.Layout view;
        new bool expand;
        
        double width_prefered = 0.0;
 
        public void show_() {
            Gtk.Requisition width1;
            Gtk.Requisition width2;
            child.get_preferred_size(out width1, out width2);
            width_prefered = width1.height;
            child.width_request = get_allocated_width();
            this.animate_height(expand ?  -width1.height : width1.height, 1000);
            expand = !expand;
        }
        
        public void expand_box()
        {
            Gtk.Requisition width1;
            Gtk.Requisition width2;
            child.get_preferred_size(out width1, out width2);
            width_prefered = width1.height;
            child.width_request = get_allocated_width();
            expand = true;
            this.animate_height(width1.height, 1000);
        }

        double initial_height = 0.0;
        double distance;
        public void animate_height(double target_new, double duration) {
            this.target = target_new;
            distance = target_new;
            this.step = (distance / duration)*400;
            height = view.height_request;
            initial_height = height;
            this.timer_id = Timeout.add(50, height_animation);
        }
 
        private bool height_animation() {
            height += step;
            double old = view.height_request;
            view.height_request = (int)(Math.sin(height/distance*Math.PI/2)*distance);
            old = view.height_request - old;
            if(Math.fabs(this.height - initial_height) >= Math.fabs(this.target - step)) {
                if(target < 0) view.height_request = 0;
                else view.height_request = (int)width_prefered;
                return false;
            }
            return true;
        }
    }
