// -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-
/***
  BEGIN LICENSE
	
  Copyright (C) 2013 Mario Guerriero <mario@elementaryos.org>
  This program is free software: you can redistribute it and/or modify it	
  under the terms of the GNU Lesser General Public License version 3, as published	
  by the Free Software Foundation.
	
  This program is distributed in the hope that it will be useful, but	
  WITHOUT ANY WARRANTY; without even the implied warranties of	
  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR	
  PURPOSE.  See the GNU General Public License for more details.
	
  You should have received a copy of the GNU General Public License along	
  with this program.  If not, see <http://www.gnu.org/licenses/>	
  
  END LICENSE	
***/

public class Scratch.Templates.Switchboard : Scratch.Template {
    Gtk.Grid grid;
    Gtk.Entry project_name;
    Gtk.Entry author_name;
    Gtk.Entry author_email;
    Gtk.Entry icon;
    Gtk.TextView description;
    Gtk.TextView header;
    Gtk.FileChooserButton file_chooser_button;

    public override Gtk.Widget get_creation_box () {
        grid = new Gtk.Grid ();
        grid.set_column_spacing (5);
        grid.set_row_spacing (5);
        grid.margin = 10;
        
        project_name = new Gtk.Entry ();
        project_name.placeholder_text = _("Project Name");
        project_name.hexpand = true;
        
        grid.attach (project_name, 0, 0, 2, 1);
        
        author_name = new Gtk.Entry ();
        author_name.placeholder_text = _("Author Name");
        author_name.hexpand = true;
        
        grid.attach (author_name, 0, 1, 2, 1);
        
        author_email = new Gtk.Entry ();
        author_email.placeholder_text = _("Author Email");
        author_email.hexpand = true;
        
        grid.attach (author_email, 0, 2, 2, 1);
        
        icon = new Gtk.Entry ();
        icon.placeholder_text = _("Icon Name");
        icon.hexpand = true;
        
        grid.attach (icon, 0, 3, 2, 1);
        
        description = new Gtk.TextView ();
        var scroll = new Gtk.ScrolledWindow (null, null);
        scroll.add (description);
        var description_label = new Gtk.Label ("");
        description_label.use_markup = true;
        description_label.set_markup ("<b>" + _("Project Description") + "</b>");
        
        grid.attach (description_label, 0, 4, 2, 1);
        grid.attach (scroll, 0, 5, 2, 1);
        
        header = new Gtk.TextView ();
        scroll = new Gtk.ScrolledWindow (null, null);
        scroll.add (header);
        var header_label = new Gtk.Label ("");
        header_label.use_markup = true;
        header_label.set_markup ("<b>" + _("Files Header") + "</b>");
        
        grid.attach (header_label, 0, 6, 2, 1);
        grid.attach (scroll, 0, 7, 2, 1);
        
        file_chooser_button = new Gtk.FileChooserButton (_("Create a project"), Gtk.FileChooserAction.SELECT_FOLDER);
        
        grid.attach (file_chooser_button, 0, 8, 2, 1);

        var create_button = new Gtk.Button.with_label (_("Create"));
        grid.attach (create_button, 1, 9, 1, 1);
        create_button.clicked.connect (on_create_clicked);
        
        return grid;
    }

    private void on_create_clicked () {
        var variables = new Gee.HashMap<string, string> ();
        var low = project_name.text.down ().replace(" ", "-");
        variables.set ("LOWER_CASE_NAME", low);
        variables.set ("LOWER_CASE_NAME2", low);
        variables.set ("NAME", project_name.text.replace (" ", ""));
        variables.set ("AUTHOR_NAME", author_name.text);
        variables.set ("AUTHOR_EMAIL", author_email.text);
        variables.set ("ICON", icon.text);
        var now = new DateTime.now_local ();
        variables.set ("YEAR", now.get_year ().to_string ());
        variables.set ("DESCRIPTION", description.buffer.text);
        variables.set ("HEADER", header.buffer.text);
        variables.set ("DESCRIPTION", description.buffer.text);
        variables.set ("CATEGORY", "personal");
        
        string path = Euclide.DATADIR + "plugins/euclidetemplates";
        configure_template (path + "/switchboard/", file_chooser_button.get_filename () + "/" + low + "/", variables);
        
        var file = File.new_for_path (file_chooser_button.get_filename () + "/" + low);
        loaded (file);
        
        grid.get_parent ().destroy ();
    }
}
